/* Copyright (C) 2001,2008 Martijn van Iersel and Jules Beulen
 * This program is released under the terms of the zlib license
 * See license.txt for details
 */
#include <allegro.h>
#include "hiscore.h"
#include "shandler.h"
#include "game.h"
#include "menu.h"

#ifndef NO_SOUND
#include <jgmod.h>
#endif

class MainEngine
{
private:
#ifndef NO_SOUND
    JGMOD *ex;
    bool sound_enabled;
#endif
    HiScore hiscore;
    int sequence;
    bool main_loop;
    void definecolors();
    BITMAP *background;
    void createbackground();
    ScoreHandler score;
    GameEngine ge;
    Menu menu;
    DATAFILE *data;
    FONT *font6, *font12;
public:
    void draw (BITMAP *buffer);
    void update (int msec);
    int activate ();
    void deactivate ();
    bool finished () { return !main_loop; }
    int width;
    int height;
};
